import React from 'react';

import type { GeneralSizeProp } from '@/mui/types';

import { jsRenderingSelector } from '@/modules/feeds/Editor/redux/selectors';
import { setAction } from '@/modules/feeds/Editor/redux/slices';

import { useFormSettings } from '@/modules/@common/Form';
import { useAppDispatch, useAppSelector } from '@/modules/@common/store/hooks';
import { Switch } from '@/mui/components';

type PropTypes = {
  disabled?: boolean;
};

function JsRendering({ disabled = false }: PropTypes) {
  const dispatch = useAppDispatch();
  const { size } = useFormSettings();

  const jsRendering = useAppSelector(jsRenderingSelector);

  return (
    <Switch
      data-id="jsRendering"
      size={size as GeneralSizeProp}
      color="primary"
      checked={jsRendering}
      disabled={disabled}
      onChange={(e) => dispatch(setAction({ jsRendering: e.target.checked }))}
    />
  );
}

export default JsRendering;
